#include "project.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "math.h"

#define STR_LEN 32
#define NUM_TO_RECEIVE 2

uint8_t Bytes_In[NUM_TO_RECEIVE] ;
volatile int in_index = 0 ; 
volatile int data_received = 0 ;
char str[STR_LEN+1] ; /* print buffer */

uint8_t Data_in ;

CY_ISR(RX_Handler)
{
	while(UART_GetRxBufferSize()) {
		Bytes_In[in_index] = UART_GetByte() ;
		in_index++ ;
		if (in_index >= NUM_TO_RECEIVE) {
			data_received = 1 ;
			in_index = 0 ;
			break ;
		}
	}
	UART_ReadRxStatus() ; // this clears interrupt flag
}

void SYS_INIT(void)
{
	UART_Terminal_Start() ;
	
//	UART_SetRxInterruptMode(UART_RX_STS_FIFO_NOTEMPTY); // this should come before StartEx()
	
	RX_ISR_StartEx(RX_Handler);
    
    UART_Start() ;
}

void cls(void)
{
    UART_Terminal_PutString("\033c") ; /* reset */
    CyDelay(100) ;
    UART_Terminal_PutString("\033[2J") ; /* clear screen */
    CyDelay(100) ;
}

void splash(void)
{
    cls() ;
    UART_Terminal_PutString("UART 2Bytes Test ") ;
    snprintf(str, STR_LEN, "(%s %s)\n", __DATE__, __TIME__) ;
    UART_Terminal_PutString(str) ;
}
    
int main(void)
{
	CyGlobalIntEnable ; /* Enable global interrupts */
	
	SYS_INIT() ;
    
    splash() ;
	
	for (;;) {
		if (data_received) {
			snprintf(str, STR_LEN, "%02X%02X\n", Bytes_In[0], Bytes_In[1]) ;
			UART_Terminal_PutString(str) ;
			data_received = 0 ;
		}
	}
}